# Great Android Sensing Toolkit (GAST)

## Welcome to GAST!

GAST is a toolkit for using Android's Sensing capabilities. It contains the examples, boiler plate code, and algorithms you need to properly use Android sensors.

It is based on the code written for [Professional Android Sensor Programming](http://www.wiley.com/WileyCDA/WileyTitle/productCd-1118183487.html) by Greg Milette and Adam Stroud

## What Sensors?

By sensors, we mean:
*a capability that can capture measurements about the device and its external environment*

GAST provides code for the following capabilities:

* Location sensors: sensors related to the LocationProvider API 
* Physical sensors: all sensors in SensorManager API such as the ones that detect device specific properties such as orientation, acceleration, and rotation
and environmental properties such as light, magnetic fi eld, and barometric pressure.
* External sensors: Any sensor connected using the Android Open Accessory (AOA) mechanism.
* NFC
* Camera
* Microphone
* Speech recognition


## Documentation

+ [Setup](https://github.com/gast-lib/gast-lib/blob/master/Setup.md)
+ [Speech Recognition and Text-to-Speech](https://github.com/gast-lib/gast-lib/blob/master/speech.md)
+ [Audio Processing](https://github.com/gast-lib/gast-lib/blob/master/audio.md)
* (More to come)

## Learn more

+ Read the book: [Professional Android Sensor Programming](http://www.wiley.com/WileyCDA/WileyTitle/productCd-1118183487.html)
+ Download the app: [Android Sensor Playground](https://play.google.com/store/apps/details?id=root.gast.playground)

## Contact
+ [Email](mailto:gastlib@gmail.com)
+ [Github](https://github.com/gast-lib)
+ [Wrox Programmer Forums](http://p2p.wrox.com/)
+ [gastlib Google Group](http://groups.google.com/group/gastlib)

## License

All the code is licensed under the Apache 2.0 license. See [LICENSE.txt](https://github.com/gast-lib/gast-lib/blob/master/LICENSE.txt) for license details.
